"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.NDJSONParseStream = void 0;
// deno-lint-ignore-file no-explicit-any
const split_stream_js_1 = require("./split-stream.js");
/** @deprecated Untested */
class NDJSONParseStream extends TransformStream {
    constructor(opts = {}) {
        let writer;
        super({
            start(controller) {
                let decoder;
                const splitStream = new split_stream_js_1.BinarySplitStream();
                writer = splitStream.writable.getWriter();
                splitStream.readable.pipeTo(new WritableStream({
                    start() {
                        decoder = new TextDecoder();
                    },
                    write(line) {
                        const sLine = decoder.decode(line).trim();
                        if (sLine) {
                            try {
                                controller.enqueue(JSON.parse(sLine));
                            }
                            catch (err) {
                                if (opts.fatal)
                                    controller.error(err);
                            }
                        }
                    },
                })).catch(err => controller.error(err));
            },
            transform(chunk) {
                writer.write(chunk);
            },
            flush() {
                // TODO: this is not right...
                writer.close();
            },
        });
    }
}
exports.NDJSONParseStream = NDJSONParseStream;
//# sourceMappingURL=ndjson-parse-stream.js.map