declare type Awaitable<T> = T | PromiseLike<T>;
export declare class JSONParseLazyPromise<T, TT = T> implements Promise<T> {
    #private;
    static from<T>(task: () => Awaitable<T>): JSONParseLazyPromise<T, T>;
    private constructor();
    get state(): string;
    /**
     * Starts the execution of the task associated with the lazy promise.
     * If you don't want to start the task at this moment, use `.map` instead.
     */
    then<U = T, V = never>(onfulfilled?: ((value: T) => Awaitable<U>) | undefined | null, onrejected?: ((reason: any) => Awaitable<V>) | undefined | null): Promise<U | V>;
    /**
     * Applies transformations to the resolved value without triggering execution.
     * Returns another lazy promise that triggers execution via `.then`
     */
    map<U = T>(mapFn?: ((value: T, i?: 0) => Awaitable<U>) | undefined | null, thisArg?: any): JSONParseLazyPromise<U, TT>;
    catch<V = never>(onrejected?: ((reason: any) => Awaitable<V>) | null): Promise<T | V>;
    finally(onfinally?: (() => void) | null): Promise<T>;
    [Symbol.toStringTag]: string;
}
export {};
